Halide 22.0.0 Halide compiler and libraries

Public Member Functions | Public Attributes | List of all members
Halide::Internal::Autoscheduler::OptionalRational Struct Reference

`#include <FunctionDAG.h>`

## Public Member Functions
| OptionalRational ()=default
| OptionalRational (bool e, int64_t n, int64_t d)
void | operator+= (const OptionalRational &other)
OptionalRational | operator* (const OptionalRational &other) const
bool | operator< (int x) const
bool | operator<= (int x) const
bool | operator> (int x) const
bool | operator>= (int x) const
bool | operator== (int x) const
bool | operator== (const OptionalRational &other) const
bool | exists () const
| OptionalRational ()=default
| OptionalRational (int64_t n, int64_t d)
void | operator+= (const OptionalRational &other)
OptionalRational | operator* (int64_t factor) const
OptionalRational | operator* (const OptionalRational &other) const
bool | operator< (int x) const
bool | operator<= (int x) const
bool | operator> (int x) const
bool | operator>= (int x) const
bool | operator== (int x) const
bool | operator== (const OptionalRational &other) const

## Public Attributes
bool | exists = false
int64_t | numerator = 0
int64_t | denominator = 0
int32_t | numerator = 0
int32_t | denominator = 0

## Detailed Description

Definition at line 34 of file FunctionDAG.h.

## Constructor & Destructor Documentation

## ◆ OptionalRational() [1/4]

Halide::Internal::Autoscheduler::OptionalRational::OptionalRational | ( |  | ) |
| default

## ◆ OptionalRational() [2/4]

Halide::Internal::Autoscheduler::OptionalRational::OptionalRational | ( | bool | e,
|  | int64_t | n,
|  | int64_t | d
| ) |  |
| inline

Definition at line 39 of file FunctionDAG.h.

## ◆ OptionalRational() [3/4]

Halide::Internal::Autoscheduler::OptionalRational::OptionalRational | ( |  | ) |
| default

## ◆ OptionalRational() [4/4]

Halide::Internal::Autoscheduler::OptionalRational::OptionalRational | ( | int64_t | n,
|  | int64_t | d
| ) |  |
| inline

Definition at line 40 of file FunctionDAG.h.

## Member Function Documentation

## ◆ operator+=() [1/2]

void Halide::Internal::Autoscheduler::OptionalRational::operator+= | ( | const OptionalRational & | other | ) |
| inline

Definition at line 43 of file FunctionDAG.h.

References denominator, exists, Halide::Internal::gcd(), Halide::Internal::lcm(), and numerator.

## ◆ operator*() [1/3]

OptionalRational Halide::Internal::Autoscheduler::OptionalRational::operator* | ( | const OptionalRational & | other | ) | const
| inline

Definition at line 62 of file FunctionDAG.h.

References denominator, exists, and numerator.

## ◆ operator<() [1/2]

bool Halide::Internal::Autoscheduler::OptionalRational::operator< | ( | int | x | ) | const
| inline

Definition at line 79 of file FunctionDAG.h.

References denominator, exists, and numerator.

## ◆ operator<=() [1/2]

bool Halide::Internal::Autoscheduler::OptionalRational::operator<= | ( | int | x | ) | const
| inline

Definition at line 90 of file FunctionDAG.h.

References denominator, exists, and numerator.

## ◆ operator>() [1/2]

bool Halide::Internal::Autoscheduler::OptionalRational::operator> | ( | int | x | ) | const
| inline

Definition at line 101 of file FunctionDAG.h.

References exists.

## ◆ operator>=() [1/2]

bool Halide::Internal::Autoscheduler::OptionalRational::operator>= | ( | int | x | ) | const
| inline

Definition at line 108 of file FunctionDAG.h.

References exists.

## ◆ operator==() [1/4]

bool Halide::Internal::Autoscheduler::OptionalRational::operator== | ( | int | x | ) | const
| inline

Definition at line 115 of file FunctionDAG.h.

References denominator, exists, and numerator.

## ◆ operator==() [2/4]

bool Halide::Internal::Autoscheduler::OptionalRational::operator== | ( | const OptionalRational & | other | ) | const
| inline

Definition at line 119 of file FunctionDAG.h.

References denominator, exists, and numerator.

## ◆ exists()

bool Halide::Internal::Autoscheduler::OptionalRational::exists | ( |  | ) | const
| inline

Definition at line 35 of file FunctionDAG.h.

References denominator.

## ◆ operator+=() [2/2]

void Halide::Internal::Autoscheduler::OptionalRational::operator+= | ( | const OptionalRational & | other | ) |
| inline

Definition at line 45 of file FunctionDAG.h.

References denominator, Halide::Internal::gcd(), Halide::Internal::lcm(), and numerator.

## ◆ operator*() [2/3]

OptionalRational Halide::Internal::Autoscheduler::OptionalRational::operator* | ( | int64_t | factor | ) | const
| inline

Definition at line 64 of file FunctionDAG.h.

References denominator, and numerator.

## ◆ operator*() [3/3]

OptionalRational Halide::Internal::Autoscheduler::OptionalRational::operator* | ( | const OptionalRational & | other | ) | const
| inline

Definition at line 72 of file FunctionDAG.h.

References denominator, and numerator.

## ◆ operator<() [2/2]

bool Halide::Internal::Autoscheduler::OptionalRational::operator< | ( | int | x | ) | const
| inline

Definition at line 88 of file FunctionDAG.h.

References denominator, and numerator.

## ◆ operator<=() [2/2]

bool Halide::Internal::Autoscheduler::OptionalRational::operator<= | ( | int | x | ) | const
| inline

Definition at line 98 of file FunctionDAG.h.

References denominator, and numerator.

## ◆ operator>() [2/2]

bool Halide::Internal::Autoscheduler::OptionalRational::operator> | ( | int | x | ) | const
| inline

Definition at line 108 of file FunctionDAG.h.

References exists.

## ◆ operator>=() [2/2]

bool Halide::Internal::Autoscheduler::OptionalRational::operator>= | ( | int | x | ) | const
| inline

Definition at line 115 of file FunctionDAG.h.

References exists.

## ◆ operator==() [3/4]

bool Halide::Internal::Autoscheduler::OptionalRational::operator== | ( | int | x | ) | const
| inline

Definition at line 122 of file FunctionDAG.h.

References denominator, exists, and numerator.

## ◆ operator==() [4/4]

bool Halide::Internal::Autoscheduler::OptionalRational::operator== | ( | const OptionalRational & | other | ) | const
| inline

Definition at line 126 of file FunctionDAG.h.

References denominator, exists, and numerator.

## Member Data Documentation

## ◆ exists

bool Halide::Internal::Autoscheduler::OptionalRational::exists = false

Definition at line 35 of file FunctionDAG.h.

Referenced by operator*(), operator+=(), operator<(), operator<=(), operator==(), operator>(), and operator>=().

## ◆ numerator [1/2]

int64_t Halide::Internal::Autoscheduler::OptionalRational::numerator = 0

Definition at line 36 of file FunctionDAG.h.

Referenced by operator*(), operator+=(), operator<(), operator<=(), and operator==().

## ◆ denominator [1/2]

int64_t Halide::Internal::Autoscheduler::OptionalRational::denominator = 0

Definition at line 36 of file FunctionDAG.h.

Referenced by exists(), operator*(), operator+=(), operator<(), operator<=(), and operator==().

## ◆ numerator [2/2]

int32_t Halide::Internal::Autoscheduler::OptionalRational::numerator = 0

Definition at line 33 of file FunctionDAG.h.

## ◆ denominator [2/2]

int32_t Halide::Internal::Autoscheduler::OptionalRational::denominator = 0

Definition at line 33 of file FunctionDAG.h.

The documentation for this struct was generated from the following files:

- src/autoschedulers/adams2019/FunctionDAG.h
- src/autoschedulers/anderson2021/FunctionDAG.h